#ifndef _OGREVISIBILITYPREDICTOR_H__
#define _OGREVISIBILITYPREDICTOR_H__

#include <Ogre.h>
#include "ViewCellsManager.h"
#include "HierarchyInterface.h"


namespace Ogre {
 
/** Visibility predictor
*/

class __declspec(dllexport) VisibilityPredictor
{
public:

	VisibilityPredictor();

	void HandleProbablyVisibleObjects(GtpVisibilityPreprocessor::ViewCell *vc);
	void UpdateVisibility(GtpVisibilityPreprocessor::ViewCell *vc);

	void IssueMultiQuery(const vector<Entity *> &mEntities);


protected:

	GtpVisibility::HierarchyNodeContainer mEntityBuffer;
};


} // namespace Ogre

#endif // VisibilityPredictor